#ifndef HOUSEMONITOR_H
#define HOUSEMONITOR_H

//combine function

enum MoteEnum {
  SINK_ID = 0,
  AM_HOUSEMONITOR = 6,
  SAMPLE_PERIOD = 10000,
  MAX_ROUTE_QUEUE = 10
};

enum SinkEnum {
  VAR_SAMPLE_PERIOD = 1000,
  N_SAMPLE_PERIODS = 5,
  AM_HOUSEMONITORSINK = 7,

  KEEP_ALIVE_PERIOD = 18000
};

enum MessageType {
  SENSOR_DATA=0,
  SET_SAMPLE_PERIOD,
  KEEP_ALIVE
};


typedef nx_struct SensorDataMsg {
  nx_uint8_t type;
  nx_uint16_t nodeid;
  nx_uint16_t temperature;
  nx_uint16_t humidity;
  nx_uint16_t acquisition_nr;
} SensorDataMsg;

typedef nx_struct SamplePeriodMsg {
  nx_uint8_t type;
  nx_uint32_t beacon;
  nx_uint16_t samplePeriod;
} SamplePeriodMsg;

typedef nx_struct KeepAliveMsg {
  nx_uint8_t type;
  nx_uint32_t beacon;
} KeepAliveMsg;

typedef nx_struct Mote {
  nx_uint16_t temperature;
  nx_uint16_t humidity;
  nx_uint16_t acquisition_nr;
  nx_uint16_t samplePeriod;

  nx_uint32_t lastBeacon;
  nx_uint16_t routeNode;
} Mote;

typedef nx_struct Sink {
  nx_uint32_t beacon;
  nx_uint16_t samplePeriod;
  nx_uint16_t keepAlivePeriod;
} Sink;

/* Helper structs*/

typedef nx_struct MessageHeader {
  nx_uint8_t type;
} MessageHeader;

#endif
