#!/usr/bin/python

N_MOTES = 3
DBG_CHANNELS = "Debug default error"
SIM_TIME = 70
#TOPO_FILE = "linkgain.out"
TOPO_FILE = "topo.txt"
#NOISE_FILE = "/opt/tinyos-2.1.0/tos/lib/tossim/noise/TTX4-short.txt"
NOISE_FILE = "meyer-short.txt"

from TOSSIM import *
from tinyos.tossim.TossimApp import *
from random import *
import sys

t = Tossim([])
r = t.radio()

t.randomSeed(1)

for channel in DBG_CHANNELS.split():
    t.addChannel(channel, sys.stdout)


#add gain links
f = open(TOPO_FILE, "r")
lines = f.readlines()

for line in lines:
    s = line.split()
    if (len(s) > 0):
        print " ", s[0], " ", s[1], " ", s[2]
        r.add(int(s[0]), int(s[1]), float(s[2]))
	
#add noise trace
noise = open(NOISE_FILE, "r")
lines = noise.readlines()
for line in lines:
    str = line.strip()
    if (str != ""):
        val = int(str)
        for i in range(0, N_MOTES):
            t.getNode(i).addNoiseTraceReading(val)


for i in range (0, N_MOTES):
    time=i * t.ticksPerSecond() / 100
    m=t.getNode(i)
    m.bootAtTime(time)
    m.createNoiseModel()
    print "Booting ", i, " at ~ ", int(time/t.ticksPerSecond()), "s (",time,")"

time = t.time()
lastTime = -1
while (time + SIM_TIME * t.ticksPerSecond() > t.time()):
    timeTemp = int(t.time()/(t.ticksPerSecond()*10))
    if( timeTemp > lastTime ): #stampa un segnale ogni 10 secondi... per leggere meglio il log
        lastTime = timeTemp
        print "----------------------------------SIMULATION: ~", lastTime*10, " s ----------------------"
    t.runNextEvent()
print "----------------------------------END OF SIMULATION-------------------------------------"
